# -*- coding: utf-8 -*-
"""
Created on Sat Sep 26 09:56:23 2015

@author: pascal
"""

import numpy as np
from matplotlib import pyplot as plt

U0=1
omega_m=2*np.pi
omega_p=50*omega_m
m=.9
#tau=.1
tmax=2*np.pi/omega_m
N=50001
dt=tmax/(N-1)

def tauMax(omega_m,m):
    return np.sqrt(1-m**2)/m/omega_m
    
tau=tauMax(omega_m,m)-0.07

def ue(t):
    return U0*(1+m*np.cos(omega_m*t))*np.cos(omega_p*t)
    
def f(t):#calcul de ue+tau*due/dt
    return (1+m*np.cos(omega_m*t))*np.cos(omega_p*t)-tau*(omega_p*(1+m*np.cos(omega_m*t))*np.sin(omega_p*t)+m*omega_m*np.sin(omega_m*t)*np.cos(omega_p*t))
    
# def ue(t):
#     return U0*(1+m*np.cos(omega_m*t))
#     
# def f(t):#calcul de ue+tau*due/dt
#     return (1+m*np.cos(omega_m*t))-tau*m*omega_m*np.sin(omega_m*t)
    
T=[i*dt for i in range(N)]
Ue=[ue(i*dt) for i in range(N)]
Test=[f(i*dt) for i in range(N)]
Us=[0.]*N
Us[0]=Ue[0]

i=0


for i in range(1,N):
    if Us[i-1]==Ue[i-1]:#la diode était passante
        if Test[i]>=0:#l'est-elle encore?
            Us[i]=Ue[i]
        else:
            Us[i]=Us[i-1]*np.exp(-dt/tau)
    if Us[i-1]!=Ue[i-1]:#la diode était bloquée
        essai=Us[i-1]*np.exp(-dt/tau)
        if essai>Ue[i]:#l'est-elle encore?
            Us[i]=essai
        else:
            Us[i]=Ue[i]
            
plt.ylim(-2,2)
plt.plot(T,Ue)
plt.plot(T,Us)
plt.show()       
        
        
  
     